unit u0Coder;{    
  0Coder`,  PELoad   
   DelphiPEload }

interface
uses uKOStype,uKOSfuncs,uKOSconst;
Procedure On_Key;
Procedure On_Button;
Function CreateFile(Path: PChar): Integer;StdCall;
Function  RunFile(Path, Params: PChar): Integer; StdCall;
Function  LoadLibrary(Path: PChar): Pointer; StdCall;
Function  GetProcAddress(hLib: Pointer; ProcName: PChar): Pointer; StdCall;
Function  SetEventMask(Mask: Dword): Dword; StdCall;

implementation

Procedure On_Key;
Begin
  GetKey;
End;

Procedure On_Button;
Begin
  Case GetButton() Shr 8 Of
  1 : ThreadTerminate;
  End;
End;

Function CreateFile(Path: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   0
        push   0
        push   2
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;

Function RunFile(Path, Params: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   Params
        push   0
        push   7
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;

Function LoadLibrary(Path: PChar): Pointer;
Asm
        push   ebx
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, Path
        int    64
        pop    ebx
End;

Function GetProcAddress(hLib: Pointer; ProcName: PChar): Pointer;
Asm
        push   esi
        push   edi
        push   ebx
        mov    edx, hLib
        xor    eax, eax
        test   edx, edx
        jz     @end
        mov    edi, ProcName
        mov    ecx, $FFFFFFFF
        repne scasb
        mov    ebx, ecx
        not    ebx
@next:
        mov    esi, [edx]
        test   esi, esi
        jz     @end
        mov    ecx, ebx
        mov    edi, ProcName
        add    edx, 8
        repe cmpsb
        jne    @next
        mov    eax, [edx - 4]
@end:
        pop    ebx
        pop    edi
        pop    esi
End;

Function SetEventMask(Mask: Dword): Dword;
Asm
        push   ebx
        mov    eax, 40
        mov    ebx, Mask
        int    64
        pop    ebx
End;

end.
