unit uKOSfuncs;{  ,  _DOC\sysfuncr.txt}
interface
uses uKOSconst,{    , unit uKOSfuncs }
uKOStype;{ }


procedure TerminateProcess;{ -1 -   /}
procedure TerminateThread;{ -1 -   /}
procedure ThreadTerminate;{ -1 -   /}
{^^^^^^^^^^       ! ^^^^^^^^^^^^^^^^}

Procedure DrawWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);StdCall;
Procedure CreateWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);StdCall;
{^^^^^^^^^^        ! ^^^^^^^^^^^^^^^^}
{ 0 -    .}
{Left -    x
Top -    y
Right -    x
Bottom -    y
Caption -  
BackColor -  
Style  -  
CapStyle -  }

procedure PutPixel(x,y,Color:Cardinal);StdCall;
{ 1 -    .}
{ x -   x- ( )
 y -  y- ( )
 Color- 0x00RRGGBB -  . 0x01xxxxxx -   
   ( 24  )}
function GetKey: cardinal;
{ 2 -    .}
{
 }

Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword);StdCall;
{  ( 4)}
{X -     
Y -     
Text -    
ForeColor - (Flags = Flags  ForeColor)
BackColor -  B=1 -    ,  C=1 -   
Flags -  0xXXRRGGBB, 
    * RR, GG, BB   
    * XX=ABFFCSSS ():
      * A=1 -    
      * B=1 -   ( = edi)
      * FF    :
        0 = 6x9  cp866
        1 = 8x16 cp866
        2 = 8x16 UTF-16LE
        3 = 8x16 UTF-8
      * C=0 -   ,
        =1 -    (edi)
      * SSS = ( )-1, - 0 = x1, 7 = x8
Count -  A=0  ,  A=1 
:
  *    B=1  C=1,
          edi.
  *  SSS=0,   ,
        .
  *  :
Xsize       dd
Ysize       dd
picture     rb  Xsize*Ysize*4  ; 32 }

Procedure Sleep(c:Cardinal);StdCall;
{     .( 5 - )}
{ -     }

Procedure DrawButton(Left, Top, Right, Bottom: Integer; BackColor, Style, ID: Dword); StdCall;
{/  ( 8)}
{Left -    x
Top -    y
Right -    x
Bottom -    y
BackColor - 0x00RRGGBB -  
Style - ( ID = ID  Style )
ID- 0x80nnnnnn,  nnnnnn -  
    * nnnnnn =  
    *  (31-)  ID 
    *  30-  ID  -   
    *  29-  ID  -   
         
   :
  * edx = 0x80nnnnnn,  nnnnnn -  
:
  *      0   0x8000.
  *        ( 0- )
        -  
      1      0xffff.
  *      
     .
  *    0xffff   
       ,   
     ,    .
        .
  *       
     4095.}

function WaitEvent: cardinal;
{ 10 -  .}
{  -   (    sysfuncr.txt)}

function CheckEvent: cardinal;
{ 11 - ,   ,  .}
{ : 0 -   ,
 =  (  )}

procedure Redraw(c:Cardinal); StdCall;
{ 12 - /  .}
{ c = 1 -   
 c =  2 -   }

  procedure BeginDraw;
  {   ( 12  1)}

  Procedure EndDraw;
  {   ( 12  2 )}

Procedure DrawRect(Left, Top, Right, Bottom: Integer;Color: Dword);StdCall;
{    ( 13)}
{Left -    x
Top -    y
Right -    x
Bottom -    y
Color -  0xRRGGBB  0x80RRGGBB   
:       
      .}

function GetButton: cardinal;
{ 17 -    }
{ :  *   ,  - 1
   :
    *  24  eax   
      ( ,  ah    ;
          ,  256,
          ah)
    * al = 0 -      
    * al = ,    ,   
}

Procedure DrawLine(Left, Top, Right, Bottom: Integer;Color : Dword);StdCall;
{  ( 38)}
{Left -     x
Top -     y
Right -     x
Bottom -     y
Color -  0x00RRGGBB - , 0x01xxxxxx -   
     ( 24  )
:
  *    .
  *    .}

function GetScreenSize : SIZE;
{   
 :
  SIZE.Height -    y
  SIZE.Width -    x
( 61,   - 1) }

procedure SetModeKeyboards(c:Cardinal);StdCall;
{    . ( 66 ,  1) }
{ c =  0 -  (ASCII-)
 c =   1 - }


implementation


procedure TerminateThread;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;
procedure TerminateProcess;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;
procedure ThreadTerminate;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;

Procedure DrawWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);
{ 0 -    .}
{Left -    x
Top -    y
Right -    x
Bottom -    y
Caption -  
BackColor -  
Style  -  
CapStyle -  }
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;

Procedure CreateWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);
{ 0 -    .}
{Left -    x
Top -    y
Right -    x
Bottom -    y
Caption -  
BackColor -  
Style  -  
CapStyle -  }
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;

procedure PutPixel(x,y,Color:Cardinal);
{ 1 -    .}
{ x -   x- ( )
 y -  y- ( )
 Color- 0x00RRGGBB -  . 0x01xxxxxx -   
   ( 24  )}
asm
        push   eax
        push   ebx
        push   ecx
        push   edx
        mov    ebx, [x]
        mov    ecx, [y]
        mov    edx, [Color]
        mov    eax, SF_PUT_PIXEL { 1 -    .}
        int    64
        pop    edx
        pop    ecx
        pop    ebx
        pop    eax
end;

function GetKey: cardinal;
{ 2 -    .}
{
}
Asm
        mov    eax, SF_GET_KEY { 2 -    .}
        int    64
end;

Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword);StdCall;
{  ( 4)}
{X -     
Y -     
Text -    
ForeColor - (Flags = Flags  ForeColor)
BackColor -  B=1 -    ,  C=1 -   
Flags -  0xXXRRGGBB, 
    * RR, GG, BB   
    * XX=ABFFCSSS ():
      * A=1 -    
      * B=1 -   ( = edi)
      * FF    :
        0 = 6x9  cp866
        1 = 8x16 cp866
        2 = 8x16 UTF-16LE
        3 = 8x16 UTF-8
      * C=0 -   ,
        =1 -    (edi)
      * SSS = ( )-1, - 0 = x1, 7 = x8
Count -  A=0  ,  A=1 
:
  *    B=1  C=1,
          edi.
  *  SSS=0,   ,
        .
  *  :
Xsize       dd
Ysize       dd
picture     rb  Xsize*Ysize*4  ; 32 }
Asm
        push   ebx
        push   edi
        push   esi
        mov    eax, SF_DRAW_TEXT  {  ( 4)}
        mov    ebx, X
        shl    ebx, 16
        add    ebx, Y
        mov    ecx, Flags
        or     ecx, ForeColor
        mov    edx, Text
        mov    edi, BackColor
        mov    esi, Count
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;


Procedure Sleep(c:Cardinal);
{     .( 5 - )}
{ -     }
Asm
        push   ebx
        mov    eax, SF_SLEEP { 5 - }
        mov    ebx,[c]
        int    64
        pop    ebx
end;

Procedure DrawButton(Left, Top, Right, Bottom: Integer; BackColor, Style, ID: Dword);
{/  ( 8)}
{Left -    x
Top -    y
Right -    x
Bottom -    y
BackColor - 0x00RRGGBB -  
Style - ( ID = ID  Style )
ID- 0x80nnnnnn,  nnnnnn -  
    * nnnnnn =  
    *  (31-)  ID 
    *  30-  ID  -   
    *  29-  ID  -   
         
   :
  * edx = 0x80nnnnnn,  nnnnnn -  
:
  *      0   0x8000.
  *        ( 0- )
        -  
      1      0xffff.
  *      
     .
  *    0xffff   
       ,   
     ,    .
        .
  *       
     4095.}
Asm
        push   ebx
        push   esi
        mov    eax, SF_DEFINE_BUTTON   {/  ( 8)}
        mov    ebx, Left
        mov    ecx, Top
        shl    ebx, 16
        shl    ecx, 16
        add    ebx, Right
        add    ecx, Bottom
        mov    edx, ID
        or     edx, Style
        mov    esi, BackColor
        int    64
        pop   esi
        pop   ebx
End;


function WaitEvent: cardinal;
{ 10 -  .}
{  -   (    sysfuncr.txt)}
Asm
        mov    eax, SF_WAIT_EVENT;{ 10 -  .}
        int    64
end;

function CheckEvent: cardinal;
{ 11 - ,   ,  .}
{ : 0 -   ,
 =  (  )}
Asm
        mov    eax, SF_CHECK_EVENT;
        int    64
end;

procedure Redraw(c:Cardinal);
{ 12 - /  .}
{ c = 1 -   
 c =  2 -   }
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx,[c]
        int    64
        pop    ebx
end;

procedure BeginDraw;
{   ( 12  1)}
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx, SSF_BEGIN_DRAW { 1   }
        int    64
        pop    ebx
End;

  Procedure EndDraw;
 {   ( 12  2 )}
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx, SSF_END_DRAW { 2   .}
        int    64
        pop    ebx
End;

Procedure DrawRect(Left, Top, Right, Bottom: Integer;
Color: Dword);
{    ( 13)}
{Left -    x
Top -    y
Right -    x
Bottom -    y
Color -  0xRRGGBB  0x80RRGGBB   
:       
      .}
Asm
        push   ebx
        push   edi
        push   esi
        mov    eax, SF_DRAW_RECT{ 13 -    }
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Color
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;


function GetButton: cardinal;
{ 17 -    }
{ :  *   ,  - 1
   :
    *  24  eax   
      ( ,  ah    ;
          ,  256,
          ah)
    * al = 0 -      
    * al = ,    ,   
}
Asm
        mov    eax, SF_GET_BUTTON { 17 -    }
        int    64
end;

Procedure DrawLine(Left, Top, Right, Bottom: Integer;
Color : Dword);
{  ( 38)}
{Left -     x
Top -     y
Right -     x
Bottom -     y
Color -  0x00RRGGBB - , 0x01xxxxxx -   
     ( 24  )
:
  *    .
  *    .}
Asm
        push   ebx
        push   edi
        push   esi
        mov    eax, SF_DRAW_LINE{ 38 -  }
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Color
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;


function GetScreenSize : SIZE;
{   
 :
  SIZE.Height -    y
  SIZE.Width -    x
( 61,   - 1) }

Asm
        push   ebx
        mov    eax, SF_GET_GRAPHICAL_PARAMS;{ 61 -       .}
        mov    ebx, 1
        int    64
        pop    ebx
end;


procedure SetModeKeyboards(c:Cardinal);
{    . ( 66 ,  1) }
{ c =  0 -  (ASCII-)
 c =   1 - }
asm
        push   eax
        push   ebx
        push   ecx
        mov    ebx, SSF_SET_INPUT_MODE{ 1 -     .}
        mov    ecx, [c]
        mov    eax, SF_KEYBOARD { 66 -   }
        int    64
        pop    ecx
        pop    ebx
        pop    eax
end;






end.



